#!/bin/bash
. /var/packages/MailPlus-Server/target/backend_hook/hookUtils.conf
loadEnv

## Check identity
NODE_ID=$(getHostID)
mailer_servers="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal "mailer")"
if ! containString "${NODE_ID}" "${mailer_servers}"; then
	exit 0
fi

## Convert syno config
## Currently, only generate valid user list,
## Should limit to "user_limit", "local_license_validity" and
## "active_user_list_db" key change
if isKeyChanged "user_limit" || isKeyChanged "local_license_validity" || isKeyChanged "active_user_list_db"; then
	if ! ${SET_CONF_BINARY} "license"; then
		## SET_CONF_BINARY will be terminated when other ${SET_CONF_BINARY} license run...
		err_log "Failed to set conf license"
		#	exit 1
	fi
	if ! ${CALLBACK_BINARY} "valid_user_list" "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to callback valid_user_list"
	fi
fi

## Enable/Disable Rspamd DNSBL
if isKeyChanged "license_mode"; then
	if ! ${SET_CONF_BINARY} "rspamd"; then
		err_log "Failed to set conf rspamd"
		exit 1
	fi
fi

if isKeyChanged "license_mode"; then
	## Restart/Reload Rspamd for Rspamd DNSBL
	if ! ${CALLBACK_BINARY} "rspamd" "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to callback rspamd"
		exit 1
	fi
	## Stop phishing update
	if ! ${CALLBACK_BINARY} "setPhishingUpdateTask" "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to setPhishingUpdateTask"
	fi
fi

## Actions
#/var/packages/MailPlus-Server/target/scripts/daemon/postfix.sh reload
#/var/packages/MailPlus-Server/target/scripts/daemon/dovecot.sh restart

exit 0
