#!/bin/bash
. /var/packages/MailPlus-Server/target/backend_hook/hookUtils.conf
loadEnv

## Check identity
NODE_ID=$(getHostID)
mailer_servers="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal "mailer")"
if ! containString "${NODE_ID}" "${mailer_servers}"; then
	exit 0
fi

## Convert syno config
if ! ${SET_CONF_BINARY} "smtp"; then
	err_log "Failed to set conf smtp"
	exit 1
fi


## Convert syno config
if ! ${SET_CONF_BINARY} "rspamd"; then
	err_log "Failed to set conf rspamd"
	exit 1
fi

## Actions
if ! ${CALLBACK_BINARY} "rspamd" "${_MAIL_mailserver_trigger_events}"; then
	err_log "Failed to callback rspamd"
	exit 1
fi

exit 0
