#!/bin/bash
. /var/packages/MailPlus-Server/target/backend_hook/hookUtils.conf
loadEnv

## Check identity
NODE_ID=$(getHostID)
HAPROXY_SCRIPT="/var/packages/MailPlus-Server/target/scripts/daemon/haproxy.sh"
mailer_servers="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal "mailer")"
enable_balancer_address="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal "enable_balancer_address")"
exit_status=0
if ! containString "${NODE_ID}" "${mailer_servers}"; then
	exit ${exit_status}
fi

if isKeyChanged "enable_balancer_address"; then
	if [ "${enable_balancer_address}" == "no" ]; then
		## Have to disable haproxy due it may contain port which smtp/s/tls used
		${HAPROXY_SCRIPT} stop
	fi
fi

smtpActions()
{
	if ! ${CALLBACK_BINARY} "client_smtp_change" "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to callback client_smtp_change"
		exit_status=1
	fi
	if ! reloadSmtp "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to reload smtp"
		exit_status=1
	fi
}

spamActions()
{
	if isKeyChanged "message_limit"; then
		if ! ${SET_CONF_BINARY} "rspamd"; then
			err_log "Failed to set conf rspamd"
			exit_status=1
			return
		fi

		if ! ${CALLBACK_BINARY} "rspamd" "${_MAIL_mailserver_trigger_events}"; then
			err_log "Failed to callback rspamd"
			exit_status=1
			return
		fi
	fi
}

# user policy setting will be regenerated in smtp actions
smtpActions
spamActions

exit ${exit_status}
