#!/bin/bash
. /var/packages/MailPlus-Server/target/backend_hook/hookUtils.conf
loadEnv

## Check identity
NODE_ID=$(getHostID)
mailer_servers="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal "mailer")"
if ! containString "${NODE_ID}" "${mailer_servers}"; then
	exit 0
fi

## Configs
# For BitDefender
if isKeyChanged "anti_virus_auto_update" || isKeyChanged "anti_virus_db_update_frequency"; then
	if ! ${SET_CONF_BINARY} "rspamd"; then
		err_log "Failed to set conf rspamd"
		exit 1
	fi
fi

## Actions
# For BitDefender
if isKeyChanged "anti_virus_auto_update" || isKeyChanged "anti_virus_db_update_frequency"; then
	if ! ${CALLBACK_BINARY} "rspamd" "${_MAIL_mailserver_trigger_events}"; then
		err_log "Failed to callback rspamd"
		exit 1
	fi
fi

if ! ${CALLBACK_BINARY} "antivirus" "${_MAIL_mailserver_trigger_events}"; then
	err_log "Failed to callback antivirus"
	exit 1
fi

exit 0
