#!/bin/bash

MAILPLUS_SERVER_DIR=$1
MAILPLUS_SERVER_TARGERT_DIR="/var/packages/MailPlus-Server/target"
MAILPLUS_SERVER_VOLUME=$(readlink ${MAILPLUS_SERVER_TARGERT_DIR} | /usr/bin/cut -d'/' -f2)

#destination directory is missing
if [ -z "${MAILPLUS_SERVER_DIR}" ]; then
	return
fi

#check if mailplus server is installed
if [ ! -d ${MAILPLUS_SERVER_TARGERT_DIR} ]; then
	return
fi

mkdir -p "${MAILPLUS_SERVER_DIR}" &> /dev/null

COPY_FILES="/${MAILPLUS_SERVER_VOLUME}/@maillog/MailPlus_Server.log*
/var/log/mailplus_server.log*
/${MAILPLUS_SERVER_VOLUME}/@MailPlus-Server/aggr_log/aggr_maillog*
/${MAILPLUS_SERVER_VOLUME}/@maillog/clusterScript.log
/${MAILPLUS_SERVER_VOLUME}/@maillog/redis.log
/${MAILPLUS_SERVER_VOLUME}/@maillog/maillog*
/${MAILPLUS_SERVER_VOLUME}/@maillog/clamd.log*
/${MAILPLUS_SERVER_VOLUME}/@maillog/freshclam.log*
/${MAILPLUS_SERVER_VOLUME}/@maillog/rspamd_redis.log
/${MAILPLUS_SERVER_VOLUME}/@maillog/sa-update.log
/${MAILPLUS_SERVER_VOLUME}/@maillog/imap_err.log*
/${MAILPLUS_SERVER_VOLUME}/@maillog/mailplus_err.log*
/${MAILPLUS_SERVER_VOLUME}/@maillog/synomailplus.log*"
for file in ${COPY_FILES}; do
	if [ -f "${file}" ]; then
		 /bin/cp -a "${file}" "${MAILPLUS_SERVER_DIR}"
		 new_file="${MAILPLUS_SERVER_DIR}/$(/bin/basename ${file})"
		 if [[ "${new_file}" != *".xz" ]]; then
			/bin/xz -z "${new_file}"
		 fi
	fi
done
