#!/bin/bash
if  [ ! -e "/var/packages/MailPlus-Server/target/" ]; then
	exit 0
fi

. /var/packages/MailPlus-Server/target/scripts/MailPlusServerCommon
. /var/packages/MailPlus-Server/target/scripts/daemon/util.sh
. /var/packages/MailPlus-Server/target/scripts/DsmVersionUtil.sh

HOOK_DIR="${MAIL_SERVER_PKG}/target/hook"
DIR_SRV_HOOK="${HOOK_DIR}/dir_service_hook"

SYNO_MAILPLUS_SERVERD_SCRIPT="${MAIL_SERVER_PKG}/target/scripts/daemon/syno_mailserverd.sh"

case $1 in
	--sdk-mod-ver)
		${DIR_SRV_HOOK} --sdk-mod-ver;
		;;
	--name)
		#Print package name
		echo "${MAIL_SERVER_PKG_NAME}";
		;;
	--vendor)
		#Print package vendor
		echo "${MAIL_SERVER_PKG_VERSION}";
		;;
	--pre)
		;;
	--post)
		#check if the package is enabled
		if ! isPackageStarted; then
			exit 0
		else
			#restart saslauthd to read nsswitch.conf again
			/var/packages/MailPlus-Server/target/scripts/daemon/saslauthd.sh restart
			if ! ${MAILPLUS_SERVER_BACKEND_BINARY} --isClusterInit; then
				exit 0
			fi
		fi

		#Daemon will use getpwuid_r, so need restart after join it
		${SYNO_MAILPLUS_SERVERD_SCRIPT} status
		if [ "${SERVICE_RUNNING}" -eq $? ]; then
			${SYNO_MAILPLUS_SERVERD_SCRIPT} restart
			PROCESS_PID="$(${SYNO_MAILPLUS_SERVERD_SCRIPT} pid)"
			killByPid "HUP" "${PROCESS_PID}"
		fi
		;;
	*)
		;;
esac
