#!/bin/bash
if  [ ! -e "/var/packages/MailPlus-Server/target/" ]; then
	exit 0
fi

. /var/packages/MailPlus-Server/target/scripts/MailPlusServerCommon
. /var/packages/MailPlus-Server/target/scripts/daemon/util.sh
. /var/packages/MailPlus-Server/target/scripts/DsmVersionUtil.sh

HOOK_DIR="${MAIL_SERVER_PKG}/target/hook"
DIR_SRV_HOOK="${HOOK_DIR}/dir_service_hook"

SYNO_MAILPLUS_SERVERD_SCRIPT="${MAIL_SERVER_PKG}/target/scripts/daemon/syno_mailserverd.sh"
MULTIPLE_DOMAINS_BIN="${MAIL_SERVER_PKG}/target/bin/syno_multiple_domains"
DELEGATION_BIN="${MAIL_SERVER_PKG}/target/bin/syno_delegation"
MAILBOX_BIN="${MAIL_SERVER_PKG}/target/bin/syno_mailbox"

case $1 in
	--sdk-mod-ver)
		${DIR_SRV_HOOK} --sdk-mod-ver;
		;;
	--name)
		#Print package name
		echo "${MAIL_SERVER_PKG_NAME}";
		;;
	--vendor)
		#Print package vendor
		echo "${MAIL_SERVER_PKG_VERSION}";
		;;
	--pre)
		;;
	--post)
		#check result of refresh
		if [ "0" != "${RESULT}" ]; then
			exit 0
		fi

		#check if the package is enabled or initialized
		if ! isPackageStarted || ! ${MAILPLUS_SERVER_BACKEND_BINARY} --isClusterInit; then
			exit 0
		fi

		#check if syno_mailserverd is running. If not start it
		${SYNO_MAILPLUS_SERVERD_SCRIPT} status
		if [ "${SERVICE_RUNNING}" -ne $? ]; then
			${SYNO_MAILPLUS_SERVERD_SCRIPT} start
		fi

		# Send HUP to rebuild alias and valid db and refresh multiple domains db
		PROCESS_PID="$(${SYNO_MAILPLUS_SERVERD_SCRIPT} pid)"
		killByPid "HUP" "${PROCESS_PID}"
		${MULTIPLE_DOMAINS_BIN} "refresh" &
		${DELEGATION_BIN} "refresh" &
		${MAILBOX_BIN} "refresh_account_db" &
		;;
	*)
	;;
esac
