#!/bin/bash

. /var/packages/MailPlus-Server/target/scripts/daemon/util.sh

RUNNING_STRING="running"
NEED_UPDATE_STRING="need update"
NOT_RUNNING_STRING="not running"
NOT_INSTALLED_STRING="not installed"
UNKNOWN_STRING="unknown"

package_status()
{
	local package package_status
	package="$1"
	package_status="$(synopkg status "${package}")"

	case "${package_status}" in
		*"started"*)
			return ${SERVICE_RUNNING}
			;;
		*"stopped"*)
			return ${SERVICE_NOT_RUNNING}
			;;
		*"No such package"*)
			return ${SERVICE_NOT_INSTALLED}
			;;
		*)
			return ${SERVICE_UNKNOWN}
			;;
	esac
}

print_package_status()
{
	local package package_status_ret
	package="$1"
	package_status "${package}"
	package_status_ret=$?

	if [[ "${SERVICE_RUNNING}" -eq "${package_status_ret}" ]]; then
		echo "${RUNNING_STRING}"
	elif [[ "${SERVICE_NOT_RUNNING}" -eq "${package_status_ret}" ]]; then
		echo "${NOT_RUNNING_STRING}"
	else
		echo "${NOT_INSTALLED_STRING}"
	fi
}

if [[ "${BASH_SOURCE[0]}" == "${0}" ]]; then
	case "$1" in
		status)
			print_package_status "$2"
			;;
		*)
			echo "Usage $0 {status}" >&2
			exit 1
			;;
	esac
fi
