#!/bin/bash

#Include common scripts
. /var/packages/MailPlus-Server/target/scripts/MailPlusServerCommon
. /var/packages/MailPlus-Server/target/backend_hook/hookUtils.conf
. /var/packages/MailPlus-Server/target/scripts/daemon/util.sh

MAILBOX_TOOL="${MAIL_SERVER_PKG}/target/bin/syno_mailbox"

case $1 in
    clear-and-update-all)
        ${MAILBOX_TOOL} "clear_quota_clone"
        ${MAILBOX_TOOL} "quota-conf-generate"

		tmp_user_list="$(mktemp)"
		account_type="$(${MAILPLUS_SERVER_BACKEND_BINARY} --getConfKeyVal account_type)"
        if [ "${account_type}" = "win" ]; then
            account_type="domain"
        fi
        /usr/syno/sbin/synouser --enum ${account_type} | sed '1d' > "${tmp_user_list}"

        waitTillDaemonReady "${DOVECOT_SCRIPT}"
        if [ "${SUCCESS}" -eq "$?" ]; then
            ${DOVEADM_BINARY} quota-clone force-update -F "${tmp_user_list}"
        fi
        rm -f "${tmp_user_list}"
        ;;
    update)
        ${DOVEADM_BINARY} quota-clone force-update -u "$2"
        ;;
    update-from-file)
        waitTillDaemonReady "${DOVECOT_SCRIPT}"
        if [ "${SUCCESS}" -eq "$?" ]; then
            ${DOVEADM_BINARY} quota-clone force-update -F "$2"
        fi
        ;;
    *)
        echo "Usage: $0 clear-and-update-all | update \$user | update-from-file \$file"
        ;;
esac
