#!/bin/bash

status_()
{
	initctl status pkg-MailPlus-Server_sha_daemon | grep "running"
}

start_()
{
	if ! status_; then
		initctl start pkg-MailPlus-Server_sha_daemon
	fi
}

stop_()
{
	if status_; then
		initctl stop pkg-MailPlus-Server_sha_daemon
	fi
}

restart_()
{
	initctl restart pkg-MailPlus-Server_sha_daemon
}

case "$1" in
	start)
		start_
		;;
	restart)
		restart_
		;;
	stop)
		stop_
		;;
	status)
		status_
		;;
	*)
		echo "Usage: $0 {start|stop|restart|status}" >&2
		exit 1
		;;
esac
