--[[
Copyright (c) 2000-2020 Synology Inc. All rights reserved.
]]--

local exports = {}

-- Actions
exports.SYNOLOGY_SPAM_ACTION      = 'synology_spam'
exports.SYNOLOGY_ANTIVIRUS_ACTION = 'synology_antivirus'
exports.SYNOLOGY_MCP_ACTION       = 'synology_mcp'

-- Headers
exports.SPAM_STATUS_HEADER = 'X-Synology-Spam-Status'
exports.SPAM_FLAG_HEADER   = 'X-Synology-Spam-Flag'
exports.VIRUS_HEADER       = 'X-Synology-Virus-Status'
exports.MCP_HEADER         = 'X-Synology-MCP-Status'

-- Prefixes
exports.MCP_SYMBOL_PREFIX = 'SYNO_MCP_'
exports.MCP_SCORE_SYMBOL  = 'SYNO_MCP_SCORE'
exports.ANTIVIRUS_SYMBOLS = { 'CLAM_VIRUS', 'SYNOAV_MCAFEE_VIRUS', 'BITDEFENDER_VIRUS' }
exports.ANTIVIRUS_SYMBOL_SUFFIXES = {
  '',
  '_ENCRYPTED', -- Consider encrypted symbol as virus for now
}
exports.ANTIVIRUS_FAIL_SYMBOL_SUFFIXES = {
  '_FAIL', -- failure symbol doesn't means email is virus
}
exports.ANTIVIRUS_WHITELIST_SYMBOLS = {
  'ANTIVIRUS_WHITELIST_SENDER_IP',
  'ANTIVIRUS_WHITELIST_SENDER_DOMAIN',
  'ANTIVIRUS_WHITELIST_SENDER_EMAIL',
  'ANTIVIRUS_WHITELIST_RECIPIENT_EMAIL'
}
exports.DKIM_SPAM_SYMBOL         = 'SYNO_DKIM_HEADER_SPAM'
exports.DMARC_QUARANTINE_SYMBOL  = 'SYNO_DMARC_HEADER_QUARANTINE'
exports.BITDEFENDER_SPAM_SYMBOL  = 'BITDEFENDER_SPAM'
exports.BITDEFENDER_SKIP_SYMBOL  = 'BITDEFENDER_SKIP'
exports.BITDEFENDER_CLEAN_SYMBOL = 'BITDEFENDER_CLEAN'

exports.SPAM_BLACKLIST_PREFIX = 'BLACKLIST'
exports.SPAM_WHITELIST_PREFIX = 'WHITELIST'
exports.SPAM_BLACKWHITE_INFIXES = {
  'FROM',
  'TO'
}
exports.SPAM_BLACKWHITE_SUFFIXES = {
  'ACCOUNT',
  'ADDRESS',
  'DOMAIN'
}

-- Header value
exports.YES = 'yes'
exports.NO  = 'no'

return exports
