import multiprocessing
import signal

process_pool = None
_abort_soon_event = multiprocessing.Event()
_abort_now_event = multiprocessing.Event()

def is_abort_soon_set():
    global _abort_soon_event
    return _abort_soon_event.is_set()

def is_abort_now_set():
    global _abort_now_event
    return _abort_now_event.is_set()

def set_abort_soon():
    global _abort_soon_event
    _abort_soon_event.set()

def set_abort_now():
    global _abort_now_event
    _abort_now_event.set()

def init_pool(process_number):
    global process_pool

    def init_worker():
        #only main process handle the signal
        signal.signal(signal.SIGINT, signal.SIG_IGN)
        signal.signal(signal.SIGHUP, signal.SIG_IGN)
        signal.signal(signal.SIGUSR1, signal.SIG_IGN)
        signal.signal(signal.SIGUSR2, signal.SIG_IGN)
        signal.signal(signal.SIGABRT, signal.SIG_IGN)
        signal.signal(signal.SIGTERM, signal.SIG_IGN)
        signal.signal(signal.SIGINT, signal.SIG_IGN)
        signal.signal(signal.SIGQUIT, signal.SIG_IGN)

    process_pool = multiprocessing.Pool(processes=process_number, initializer=init_worker)

def init(process_number=None):
    init_pool(process_number)
